import { NextFunction } from "express";
import { CreateErrorAttrs, HttpErrorMethodsAttr } from "../types";
import CustomError from "./CustomError";
export default abstract class HttpAbstractError {
    abstract BadRequest(attrs?: HttpErrorMethodsAttr): void;
    abstract Unauthorized(attrs?: HttpErrorMethodsAttr): void;
    abstract PaymentRequired(attrs?: HttpErrorMethodsAttr): void;
    abstract Forbidden(attrs?: HttpErrorMethodsAttr): void;
    abstract NotFound(attrs?: HttpErrorMethodsAttr): void;
    abstract MethodNotAllowed(attrs?: HttpErrorMethodsAttr): void;
    abstract NotAcceptable(attrs?: HttpErrorMethodsAttr): void;
    abstract ProxyAuthenticationRequired(attrs?: HttpErrorMethodsAttr): void;
    abstract RequestTimeout(attrs?: HttpErrorMethodsAttr): void;
    abstract Conflict(attrs?: HttpErrorMethodsAttr): void;
    abstract Gone(attrs?: HttpErrorMethodsAttr): void;
    abstract LengthRequired(attrs?: HttpErrorMethodsAttr): void;
    abstract PreconditionFailed(attrs?: HttpErrorMethodsAttr): void;
    abstract PayloadTooLarge(attrs?: HttpErrorMethodsAttr): void;
    abstract URITooLong(attrs?: HttpErrorMethodsAttr): void;
    abstract UnsupportedMediaType(attrs?: HttpErrorMethodsAttr): void;
    abstract RangeNotSatisfiable(attrs?: HttpErrorMethodsAttr): void;
    abstract ExpectationFailed(attrs?: HttpErrorMethodsAttr): void;
    abstract ImATeapot(attrs?: HttpErrorMethodsAttr): void;
    abstract MisdirectedRequest(attrs?: HttpErrorMethodsAttr): void;
    abstract UnprocessableEntity(attrs?: HttpErrorMethodsAttr): void;
    abstract Locked(attrs?: HttpErrorMethodsAttr): void;
    abstract FailedDependency(attrs?: HttpErrorMethodsAttr): void;
    abstract TooEarly(attrs?: HttpErrorMethodsAttr): void;
    abstract UpgradeRequired(attrs?: HttpErrorMethodsAttr): void;
    abstract PreconditionRequired(attrs?: HttpErrorMethodsAttr): void;
    abstract TooManyRequests(attrs?: HttpErrorMethodsAttr): void;
    abstract RequestHeaderFieldsTooLarge(attrs?: HttpErrorMethodsAttr): void;
    abstract UnavailableForLegalReasons(attrs?: HttpErrorMethodsAttr): void;
    abstract InternalServerError(attrs?: HttpErrorMethodsAttr): void;
    abstract NotImplemented(attrs?: HttpErrorMethodsAttr): void;
    abstract BadGateway(attrs?: HttpErrorMethodsAttr): void;
    abstract ServiceUnavailable(attrs?: HttpErrorMethodsAttr): void;
    abstract GatewayTimeout(attrs?: HttpErrorMethodsAttr): void;
    abstract HTTPVersionNotSupported(attrs?: HttpErrorMethodsAttr): void;
    abstract VariantAlsoNegotiates(attrs?: HttpErrorMethodsAttr): void;
    abstract InsufficientStorage(attrs?: HttpErrorMethodsAttr): void;
    abstract LoopDetected(attrs?: HttpErrorMethodsAttr): void;
    abstract BandwidthLimitExceeded(attrs?: HttpErrorMethodsAttr): void;
    abstract NotExtended(attrs?: HttpErrorMethodsAttr): void;
    abstract NetworkAuthenticationRequired(attrs?: HttpErrorMethodsAttr): void;
    protected crateError({ code, additionalProps, message }: CreateErrorAttrs): CustomError;
    protected NextError(code: number, next: NextFunction, attrs?: HttpErrorMethodsAttr): void;
}
