import { NextFunction, Request, Response } from "express";
import HttpAbstractError from "./AbstractError";
import CustomError from "./CustomError";
import { ErrorAttrs, HttpErrorMethodsAttr } from "../types";
declare class ExpressHttpError extends HttpAbstractError {
    private next;
    initializer: (req: Request, res: Response, next: NextFunction) => void;
    BadRequest: (attrs?: HttpErrorMethodsAttr) => void;
    Unauthorized: (attrs?: HttpErrorMethodsAttr) => void;
    PaymentRequired: (attrs?: HttpErrorMethodsAttr) => void;
    Forbidden: (attrs?: HttpErrorMethodsAttr) => void;
    NotFound: (attrs?: HttpErrorMethodsAttr) => void;
    MethodNotAllowed: (attrs?: HttpErrorMethodsAttr) => void;
    NotAcceptable: (attrs?: HttpErrorMethodsAttr) => void;
    ProxyAuthenticationRequired: (attrs?: HttpErrorMethodsAttr) => void;
    RequestTimeout: (attrs?: HttpErrorMethodsAttr) => void;
    Conflict: (attrs?: HttpErrorMethodsAttr) => void;
    Gone: (attrs?: HttpErrorMethodsAttr) => void;
    LengthRequired: (attrs?: HttpErrorMethodsAttr) => void;
    PreconditionFailed: (attrs?: HttpErrorMethodsAttr) => void;
    PayloadTooLarge: (attrs?: HttpErrorMethodsAttr) => void;
    URITooLong: (attrs?: HttpErrorMethodsAttr) => void;
    UnsupportedMediaType: (attrs?: HttpErrorMethodsAttr) => void;
    RangeNotSatisfiable: (attrs?: HttpErrorMethodsAttr) => void;
    ExpectationFailed: (attrs?: HttpErrorMethodsAttr) => void;
    ImATeapot: (attrs?: HttpErrorMethodsAttr) => void;
    MisdirectedRequest: (attrs?: HttpErrorMethodsAttr) => void;
    UnprocessableEntity: (attrs?: HttpErrorMethodsAttr) => void;
    Locked: (attrs?: HttpErrorMethodsAttr) => void;
    FailedDependency: (attrs?: HttpErrorMethodsAttr) => void;
    TooEarly: (attrs?: HttpErrorMethodsAttr) => void;
    UpgradeRequired: (attrs?: HttpErrorMethodsAttr) => void;
    PreconditionRequired: (attrs?: HttpErrorMethodsAttr) => void;
    TooManyRequests: (attrs?: HttpErrorMethodsAttr) => void;
    RequestHeaderFieldsTooLarge: (attrs?: HttpErrorMethodsAttr) => void;
    UnavailableForLegalReasons: (attrs?: HttpErrorMethodsAttr) => void;
    InternalServerError: (attrs?: HttpErrorMethodsAttr) => void;
    NotImplemented: (attrs?: HttpErrorMethodsAttr) => void;
    BadGateway: (attrs?: HttpErrorMethodsAttr) => void;
    ServiceUnavailable: (attrs?: HttpErrorMethodsAttr) => void;
    GatewayTimeout: (attrs?: HttpErrorMethodsAttr) => void;
    HTTPVersionNotSupported: (attrs?: HttpErrorMethodsAttr) => void;
    VariantAlsoNegotiates: (attrs?: HttpErrorMethodsAttr) => void;
    InsufficientStorage: (attrs?: HttpErrorMethodsAttr) => void;
    LoopDetected: (attrs?: HttpErrorMethodsAttr) => void;
    BandwidthLimitExceeded: (attrs?: HttpErrorMethodsAttr) => void;
    NotExtended: (attrs?: HttpErrorMethodsAttr) => void;
    NetworkAuthenticationRequired: (attrs?: HttpErrorMethodsAttr) => void;
    customError: (error: ErrorAttrs) => void;
    handler: (err: CustomError, req: Request, res: Response, next: NextFunction) => void | Response<any, Record<string, any>>;
}
declare const HttpError: ExpressHttpError;
export { HttpError };
