"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpError = void 0;
const AbstractError_1 = __importDefault(require("./AbstractError"));
const CustomError_1 = __importDefault(require("./CustomError"));
class ExpressHttpError extends AbstractError_1.default {
    constructor() {
        super(...arguments);
        this.initializer = (req, res, next) => {
            this.next = next;
            return next();
        };
        this.BadRequest = (attrs) => {
            const code = 400;
            return this.NextError(code, this.next, attrs);
        };
        this.Unauthorized = (attrs) => {
            const code = 401;
            return this.NextError(code, this.next, attrs);
        };
        this.PaymentRequired = (attrs) => {
            const code = 402;
            return this.NextError(code, this.next, attrs);
        };
        this.Forbidden = (attrs) => {
            const code = 403;
            return this.NextError(code, this.next, attrs);
        };
        this.NotFound = (attrs) => {
            const code = 404;
            return this.NextError(code, this.next, attrs);
        };
        this.MethodNotAllowed = (attrs) => {
            const code = 405;
            return this.NextError(code, this.next, attrs);
        };
        this.NotAcceptable = (attrs) => {
            const code = 406;
            return this.NextError(code, this.next, attrs);
        };
        this.ProxyAuthenticationRequired = (attrs) => {
            const code = 407;
            return this.NextError(code, this.next, attrs);
        };
        this.RequestTimeout = (attrs) => {
            const code = 408;
            return this.NextError(code, this.next, attrs);
        };
        this.Conflict = (attrs) => {
            const code = 409;
            return this.NextError(code, this.next, attrs);
        };
        this.Gone = (attrs) => {
            const code = 410;
            return this.NextError(code, this.next, attrs);
        };
        this.LengthRequired = (attrs) => {
            const code = 411;
            return this.NextError(code, this.next, attrs);
        };
        this.PreconditionFailed = (attrs) => {
            const code = 412;
            return this.NextError(code, this.next, attrs);
        };
        this.PayloadTooLarge = (attrs) => {
            const code = 413;
            return this.NextError(code, this.next, attrs);
        };
        this.URITooLong = (attrs) => {
            const code = 414;
            return this.NextError(code, this.next, attrs);
        };
        this.UnsupportedMediaType = (attrs) => {
            const code = 415;
            return this.NextError(code, this.next, attrs);
        };
        this.RangeNotSatisfiable = (attrs) => {
            const code = 416;
            return this.NextError(code, this.next, attrs);
        };
        this.ExpectationFailed = (attrs) => {
            const code = 417;
            return this.NextError(code, this.next, attrs);
        };
        this.ImATeapot = (attrs) => {
            const code = 418;
            return this.NextError(code, this.next, attrs);
        };
        this.MisdirectedRequest = (attrs) => {
            const code = 421;
            return this.NextError(code, this.next, attrs);
        };
        this.UnprocessableEntity = (attrs) => {
            const code = 422;
            return this.NextError(code, this.next, attrs);
        };
        this.Locked = (attrs) => {
            const code = 424;
            return this.NextError(code, this.next, attrs);
        };
        this.FailedDependency = (attrs) => {
            const code = 424;
            return this.NextError(code, this.next, attrs);
        };
        this.TooEarly = (attrs) => {
            const code = 425;
            return this.NextError(code, this.next, attrs);
        };
        this.UpgradeRequired = (attrs) => {
            const code = 426;
            return this.NextError(code, this.next, attrs);
        };
        this.PreconditionRequired = (attrs) => {
            const code = 428;
            return this.NextError(code, this.next, attrs);
        };
        this.TooManyRequests = (attrs) => {
            const code = 429;
            return this.NextError(code, this.next, attrs);
        };
        this.RequestHeaderFieldsTooLarge = (attrs) => {
            const code = 431;
            return this.NextError(code, this.next, attrs);
        };
        this.UnavailableForLegalReasons = (attrs) => {
            const code = 451;
            return this.NextError(code, this.next, attrs);
        };
        this.InternalServerError = (attrs) => {
            const code = 500;
            return this.NextError(code, this.next, attrs);
        };
        this.NotImplemented = (attrs) => {
            const code = 501;
            return this.NextError(code, this.next, attrs);
        };
        this.BadGateway = (attrs) => {
            const code = 502;
            return this.NextError(code, this.next, attrs);
        };
        this.ServiceUnavailable = (attrs) => {
            const code = 503;
            return this.NextError(code, this.next, attrs);
        };
        this.GatewayTimeout = (attrs) => {
            const code = 504;
            return this.NextError(code, this.next, attrs);
        };
        this.HTTPVersionNotSupported = (attrs) => {
            const code = 505;
            return this.NextError(code, this.next, attrs);
        };
        this.VariantAlsoNegotiates = (attrs) => {
            const code = 506;
            return this.NextError(code, this.next, attrs);
        };
        this.InsufficientStorage = (attrs) => {
            const code = 507;
            return this.NextError(code, this.next, attrs);
        };
        this.LoopDetected = (attrs) => {
            const code = 508;
            return this.NextError(code, this.next, attrs);
        };
        this.BandwidthLimitExceeded = (attrs) => {
            const code = 509;
            return this.NextError(code, this.next, attrs);
        };
        this.NotExtended = (attrs) => {
            const code = 510;
            return this.NextError(code, this.next, attrs);
        };
        this.NetworkAuthenticationRequired = (attrs) => {
            const code = 511;
            return this.NextError(code, this.next, attrs);
        };
        this.customError = (error) => {
            const { message, statusCode, description, errorKey, help, invalidParams } = error;
            return this.NextError(Number(statusCode), this.next, { message, description, errorKey, help, invalidParams });
        };
        this.handler = (err, req, res, next) => {
            //catch only lib's errors
            if (err instanceof CustomError_1.default) {
                const { message, statusCode, description, errorKey, help, invalidParams } = err;
                return res.status(Number(err.statusCode)).send({ error: { message, statusCode, description, errorKey, help, invalidParams } });
            }
            // continue and to next middleware and passing the error
            return this.next(err);
        };
    }
}
const HttpError = new ExpressHttpError();
exports.HttpError = HttpError;
//# sourceMappingURL=HttpError.js.map