"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestValidator = void 0;
const statuses_1 = __importDefault(require("statuses"));
const express_validator_1 = require("express-validator");
const CustomError_1 = __importDefault(require("./CustomError"));
const RequestValidator = (req, res, next) => {
    const code = 400;
    const msg = statuses_1.default.message[code];
    const key = msg.toLowerCase().replace(/ /g, "_");
    const customError = {
        statusCode: code,
        invalidParams: [],
        message: msg,
        errorKey: key,
    };
    const errorFormatter = ({ location, msg, param }) => {
        return {
            message: msg,
            param,
            location,
        };
    };
    const result = (0, express_validator_1.validationResult)(req).formatWith(errorFormatter);
    if (!result.isEmpty()) {
        customError.invalidParams = result.array();
        const error = new CustomError_1.default(customError);
        return res.status(code).send({ error });
    }
    return next();
};
exports.RequestValidator = RequestValidator;
//# sourceMappingURL=RequestValidator.js.map